(window["webpackJsonp"] = window["webpackJsonp"] || []).push([[15],{

/***/ 100:
/***/ (function(module, exports) {

module.exports = function escape(url) {
    if (typeof url !== 'string') {
        return url
    }
    // If url is already wrapped in quotes, remove them
    if (/^['"].*['"]$/.test(url)) {
        url = url.slice(1, -1);
    }
    // Should url be wrapped?
    // See https://drafts.csswg.org/css-values-3/#urls
    if (/["'() \t\n]/.test(url)) {
        return '"' + url.replace(/"/g, '\\"').replace(/\n/g, '\\n') + '"'
    }

    return url
}


/***/ }),

/***/ 16:
/***/ (function(module, exports) {

/*
	MIT License http://www.opensource.org/licenses/mit-license.php
	Author Tobias Koppers @sokra
*/
// css base code, injected by the css-loader
module.exports = function(useSourceMap) {
	var list = [];

	// return the list of modules as css string
	list.toString = function toString() {
		return this.map(function (item) {
			var content = cssWithMappingToString(item, useSourceMap);
			if(item[2]) {
				return "@media " + item[2] + "{" + content + "}";
			} else {
				return content;
			}
		}).join("");
	};

	// import a list of modules into the list
	list.i = function(modules, mediaQuery) {
		if(typeof modules === "string")
			modules = [[null, modules, ""]];
		var alreadyImportedModules = {};
		for(var i = 0; i < this.length; i++) {
			var id = this[i][0];
			if(typeof id === "number")
				alreadyImportedModules[id] = true;
		}
		for(i = 0; i < modules.length; i++) {
			var item = modules[i];
			// skip already imported module
			// this implementation is not 100% perfect for weird media query combinations
			//  when a module is imported multiple times with different media queries.
			//  I hope this will never occur (Hey this way we have smaller bundles)
			if(typeof item[0] !== "number" || !alreadyImportedModules[item[0]]) {
				if(mediaQuery && !item[2]) {
					item[2] = mediaQuery;
				} else if(mediaQuery) {
					item[2] = "(" + item[2] + ") and (" + mediaQuery + ")";
				}
				list.push(item);
			}
		}
	};
	return list;
};

function cssWithMappingToString(item, useSourceMap) {
	var content = item[1] || '';
	var cssMapping = item[3];
	if (!cssMapping) {
		return content;
	}

	if (useSourceMap && typeof btoa === 'function') {
		var sourceMapping = toComment(cssMapping);
		var sourceURLs = cssMapping.sources.map(function (source) {
			return '/*# sourceURL=' + cssMapping.sourceRoot + source + ' */'
		});

		return [content].concat(sourceURLs).concat([sourceMapping]).join('\n');
	}

	return [content].join('\n');
}

// Adapted from convert-source-map (MIT)
function toComment(sourceMap) {
	// eslint-disable-next-line no-undef
	var base64 = btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap))));
	var data = 'sourceMappingURL=data:application/json;charset=utf-8;base64,' + base64;

	return '/*# ' + data + ' */';
}


/***/ }),

/***/ 17:
/***/ (function(module, exports, __webpack_require__) {

/*
	MIT License http://www.opensource.org/licenses/mit-license.php
	Author Tobias Koppers @sokra
*/

var stylesInDom = {};

var	memoize = function (fn) {
	var memo;

	return function () {
		if (typeof memo === "undefined") memo = fn.apply(this, arguments);
		return memo;
	};
};

var isOldIE = memoize(function () {
	// Test for IE <= 9 as proposed by Browserhacks
	// @see http://browserhacks.com/#hack-e71d8692f65334173fee715c222cb805
	// Tests for existence of standard globals is to allow style-loader
	// to operate correctly into non-standard environments
	// @see https://github.com/webpack-contrib/style-loader/issues/177
	return window && document && document.all && !window.atob;
});

var getElement = (function (fn) {
	var memo = {};

	return function(selector) {
		if (typeof memo[selector] === "undefined") {
			var styleTarget = fn.call(this, selector);
			// Special case to return head of iframe instead of iframe itself
			if (styleTarget instanceof window.HTMLIFrameElement) {
				try {
					// This will throw an exception if access to iframe is blocked
					// due to cross-origin restrictions
					styleTarget = styleTarget.contentDocument.head;
				} catch(e) {
					styleTarget = null;
				}
			}
			memo[selector] = styleTarget;
		}
		return memo[selector]
	};
})(function (target) {
	return document.querySelector(target)
});

var singleton = null;
var	singletonCounter = 0;
var	stylesInsertedAtTop = [];

var	fixUrls = __webpack_require__(39);

module.exports = function(list, options) {
	if (typeof DEBUG !== "undefined" && DEBUG) {
		if (typeof document !== "object") throw new Error("The style-loader cannot be used in a non-browser environment");
	}

	options = options || {};

	options.attrs = typeof options.attrs === "object" ? options.attrs : {};

	// Force single-tag solution on IE6-9, which has a hard limit on the # of <style>
	// tags it will allow on a page
	if (!options.singleton && typeof options.singleton !== "boolean") options.singleton = isOldIE();

	// By default, add <style> tags to the <head> element
	if (!options.insertInto) options.insertInto = "head";

	// By default, add <style> tags to the bottom of the target
	if (!options.insertAt) options.insertAt = "bottom";

	var styles = listToStyles(list, options);

	addStylesToDom(styles, options);

	return function update (newList) {
		var mayRemove = [];

		for (var i = 0; i < styles.length; i++) {
			var item = styles[i];
			var domStyle = stylesInDom[item.id];

			domStyle.refs--;
			mayRemove.push(domStyle);
		}

		if(newList) {
			var newStyles = listToStyles(newList, options);
			addStylesToDom(newStyles, options);
		}

		for (var i = 0; i < mayRemove.length; i++) {
			var domStyle = mayRemove[i];

			if(domStyle.refs === 0) {
				for (var j = 0; j < domStyle.parts.length; j++) domStyle.parts[j]();

				delete stylesInDom[domStyle.id];
			}
		}
	};
};

function addStylesToDom (styles, options) {
	for (var i = 0; i < styles.length; i++) {
		var item = styles[i];
		var domStyle = stylesInDom[item.id];

		if(domStyle) {
			domStyle.refs++;

			for(var j = 0; j < domStyle.parts.length; j++) {
				domStyle.parts[j](item.parts[j]);
			}

			for(; j < item.parts.length; j++) {
				domStyle.parts.push(addStyle(item.parts[j], options));
			}
		} else {
			var parts = [];

			for(var j = 0; j < item.parts.length; j++) {
				parts.push(addStyle(item.parts[j], options));
			}

			stylesInDom[item.id] = {id: item.id, refs: 1, parts: parts};
		}
	}
}

function listToStyles (list, options) {
	var styles = [];
	var newStyles = {};

	for (var i = 0; i < list.length; i++) {
		var item = list[i];
		var id = options.base ? item[0] + options.base : item[0];
		var css = item[1];
		var media = item[2];
		var sourceMap = item[3];
		var part = {css: css, media: media, sourceMap: sourceMap};

		if(!newStyles[id]) styles.push(newStyles[id] = {id: id, parts: [part]});
		else newStyles[id].parts.push(part);
	}

	return styles;
}

function insertStyleElement (options, style) {
	var target = getElement(options.insertInto)

	if (!target) {
		throw new Error("Couldn't find a style target. This probably means that the value for the 'insertInto' parameter is invalid.");
	}

	var lastStyleElementInsertedAtTop = stylesInsertedAtTop[stylesInsertedAtTop.length - 1];

	if (options.insertAt === "top") {
		if (!lastStyleElementInsertedAtTop) {
			target.insertBefore(style, target.firstChild);
		} else if (lastStyleElementInsertedAtTop.nextSibling) {
			target.insertBefore(style, lastStyleElementInsertedAtTop.nextSibling);
		} else {
			target.appendChild(style);
		}
		stylesInsertedAtTop.push(style);
	} else if (options.insertAt === "bottom") {
		target.appendChild(style);
	} else if (typeof options.insertAt === "object" && options.insertAt.before) {
		var nextSibling = getElement(options.insertInto + " " + options.insertAt.before);
		target.insertBefore(style, nextSibling);
	} else {
		throw new Error("[Style Loader]\n\n Invalid value for parameter 'insertAt' ('options.insertAt') found.\n Must be 'top', 'bottom', or Object.\n (https://github.com/webpack-contrib/style-loader#insertat)\n");
	}
}

function removeStyleElement (style) {
	if (style.parentNode === null) return false;
	style.parentNode.removeChild(style);

	var idx = stylesInsertedAtTop.indexOf(style);
	if(idx >= 0) {
		stylesInsertedAtTop.splice(idx, 1);
	}
}

function createStyleElement (options) {
	var style = document.createElement("style");

	options.attrs.type = "text/css";

	addAttrs(style, options.attrs);
	insertStyleElement(options, style);

	return style;
}

function createLinkElement (options) {
	var link = document.createElement("link");

	options.attrs.type = "text/css";
	options.attrs.rel = "stylesheet";

	addAttrs(link, options.attrs);
	insertStyleElement(options, link);

	return link;
}

function addAttrs (el, attrs) {
	Object.keys(attrs).forEach(function (key) {
		el.setAttribute(key, attrs[key]);
	});
}

function addStyle (obj, options) {
	var style, update, remove, result;

	// If a transform function was defined, run it on the css
	if (options.transform && obj.css) {
	    result = options.transform(obj.css);

	    if (result) {
	    	// If transform returns a value, use that instead of the original css.
	    	// This allows running runtime transformations on the css.
	    	obj.css = result;
	    } else {
	    	// If the transform function returns a falsy value, don't add this css.
	    	// This allows conditional loading of css
	    	return function() {
	    		// noop
	    	};
	    }
	}

	if (options.singleton) {
		var styleIndex = singletonCounter++;

		style = singleton || (singleton = createStyleElement(options));

		update = applyToSingletonTag.bind(null, style, styleIndex, false);
		remove = applyToSingletonTag.bind(null, style, styleIndex, true);

	} else if (
		obj.sourceMap &&
		typeof URL === "function" &&
		typeof URL.createObjectURL === "function" &&
		typeof URL.revokeObjectURL === "function" &&
		typeof Blob === "function" &&
		typeof btoa === "function"
	) {
		style = createLinkElement(options);
		update = updateLink.bind(null, style, options);
		remove = function () {
			removeStyleElement(style);

			if(style.href) URL.revokeObjectURL(style.href);
		};
	} else {
		style = createStyleElement(options);
		update = applyToTag.bind(null, style);
		remove = function () {
			removeStyleElement(style);
		};
	}

	update(obj);

	return function updateStyle (newObj) {
		if (newObj) {
			if (
				newObj.css === obj.css &&
				newObj.media === obj.media &&
				newObj.sourceMap === obj.sourceMap
			) {
				return;
			}

			update(obj = newObj);
		} else {
			remove();
		}
	};
}

var replaceText = (function () {
	var textStore = [];

	return function (index, replacement) {
		textStore[index] = replacement;

		return textStore.filter(Boolean).join('\n');
	};
})();

function applyToSingletonTag (style, index, remove, obj) {
	var css = remove ? "" : obj.css;

	if (style.styleSheet) {
		style.styleSheet.cssText = replaceText(index, css);
	} else {
		var cssNode = document.createTextNode(css);
		var childNodes = style.childNodes;

		if (childNodes[index]) style.removeChild(childNodes[index]);

		if (childNodes.length) {
			style.insertBefore(cssNode, childNodes[index]);
		} else {
			style.appendChild(cssNode);
		}
	}
}

function applyToTag (style, obj) {
	var css = obj.css;
	var media = obj.media;

	if(media) {
		style.setAttribute("media", media)
	}

	if(style.styleSheet) {
		style.styleSheet.cssText = css;
	} else {
		while(style.firstChild) {
			style.removeChild(style.firstChild);
		}

		style.appendChild(document.createTextNode(css));
	}
}

function updateLink (link, options, obj) {
	var css = obj.css;
	var sourceMap = obj.sourceMap;

	/*
		If convertToAbsoluteUrls isn't defined, but sourcemaps are enabled
		and there is no publicPath defined then lets turn convertToAbsoluteUrls
		on by default.  Otherwise default to the convertToAbsoluteUrls option
		directly
	*/
	var autoFixUrls = options.convertToAbsoluteUrls === undefined && sourceMap;

	if (options.convertToAbsoluteUrls || autoFixUrls) {
		css = fixUrls(css);
	}

	if (sourceMap) {
		// http://stackoverflow.com/a/26603875
		css += "\n/*# sourceMappingURL=data:application/json;base64," + btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap)))) + " */";
	}

	var blob = new Blob([css], { type: "text/css" });

	var oldSrc = link.href;

	link.href = URL.createObjectURL(blob);

	if(oldSrc) URL.revokeObjectURL(oldSrc);
}


/***/ }),

/***/ 2011:
/***/ (function(module, exports) {

/*
 * Tine 2.0
 * 
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Philipp Schüle <p.schuele@metaways.de>
 * @copyright   Copyright (c) 2011 Metaways Infosystems GmbH (http://www.metaways.de)
 */
Ext.ns('Tine.Projects');
/**
 * Foreign Record Filter
 * 
 * @namespace   Tine.Projects
 * @class       Tine.Projects.ProjectAttendeeFilter
 * @extends     Tine.widgets.grid.ForeignRecordFilter
 * 
 * <p>Filter for project attendee</p>
 * 
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Philipp Schüle <p.schuele@metaways.de>
 * 
 * @param       {Object} config
 * @constructor
 */

Tine.Projects.ProjectAttendeeFilter = Ext.extend(Tine.widgets.grid.ForeignRecordFilter, {
  /**
   * @cfg {Record} foreignRecordClass (required)
   */
  foreignRecordClass: Tine.Addressbook.Model.Contact,

  /**
   * @cfg {String} ownField (required)
   */
  ownField: 'contact',
  initComponent: function initComponent() {
    this.label = this.app.i18n._('Attendee');
    Tine.Projects.ProjectAttendeeFilter.superclass.initComponent.call(this);
  },

  /**
   * get subfilter models
   * @return Array of filter models
   */
  getSubFilters: function getSubFilters() {
    var attendeeRoleFilter = new Tine.Tinebase.widgets.keyfield.Filter({
      label: this.app.i18n._('Attendee Role'),
      field: 'relation_type',
      app: this.app,
      keyfieldName: 'projectAttendeeRole'
    });
    return [attendeeRoleFilter];
  }
});
Tine.widgets.grid.FilterToolbar.FILTERS['tine.projects.attendee'] = Tine.Projects.ProjectAttendeeFilter;

/***/ }),

/***/ 2012:
/***/ (function(module, exports) {

/*
 * Tine 2.0
 * 
 * @package     Projects
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Alexander Stintzing <alex@stintzing.net>
 * @copyright   Copyright (c) 2009-2011 Metaways Infosystems GmbH (http://www.metaways.de)
 *
 */
Ext.ns('Tine.Projects');
/**
 * @namespace   Tine.Projects
 * @class       Tine.Projects.AddressbookGridPanelHook
 * 
 * <p>Projects Addressbook Hook</p>
 * <p>
 * </p>
 * 
 * @author      Alexander Stintzing <alex@stintzing.net>
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * 
 * @constructor
 */

Tine.Projects.AddressbookGridPanelHook = Ext.extend(Tine.Addressbook.GenericContactGridPanelHook, {
  modelName: 'Project'
});

/***/ }),

/***/ 2013:
/***/ (function(module, exports) {

/**
 * Tine 2.0
 * 
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Philipp Schüle <p.schuele@metaways.de>
 * @copyright   Copyright (c) 2011-2021 Metaways Infosystems GmbH (http://www.metaways.de)
 */
Ext.ns('Tine.Projects');
/**
 * @namespace   Tine.Projects
 * @class       Tine.Projects.ProjectEditDialog
 * @extends     Tine.widgets.dialog.EditDialog
 * 
 * <p>Project Compose Dialog</p>
 * <p></p>
 * 
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Philipp Schüle <p.schuele@metaways.de>
 * 
 * @param       {Object} config
 * @constructor
 * Create a new Tine.Projects.ProjectEditDialog
 */

Tine.Projects.ProjectEditDialog = Ext.extend(Tine.widgets.dialog.EditDialog, {
  /**
   * @private
   */
  windowNamePrefix: 'ProjectEditWindow_',
  appName: 'Projects',
  modelName: 'Project',
  evalGrants: true,
  showContainerSelector: true,
  hideRelationsPanel: false,
  displayNotes: true,

  /**
   * overwrite update toolbars function (we don't have record grants yet)
   * @private
   */
  updateToolbars: function updateToolbars() {},

  /**
   * executed after record got updated from proxy
   * @private
   */
  onAfterRecordLoad: function onAfterRecordLoad() {
    Tine.Projects.ProjectEditDialog.superclass.onAfterRecordLoad.call(this);
    this.contactLinkPanel.onRecordLoad(this.record);
  },

  /**
   * executed when record gets updated from form
   * - add attachments to record here
   * 
   * @private
   */
  onRecordUpdate: function onRecordUpdate() {
    Tine.Projects.ProjectEditDialog.superclass.onRecordUpdate.call(this);
    var _ = window.lodash,
        relations = this.record.get('relations');
    relations = relations.filter(function (element) {
      if (element.type == 'COWORKER' || element.type == 'RESPONSIBLE') {
        return null;
      } else return element;
    });
    relations = _.concat(relations, this.contactLinkPanel.getData());
    this.record.set('relations', relations);
  },

  /**
   * returns dialog
   * 
   * NOTE: when this method gets called, all initalisation is done.
   * 
   * @return {Object}
   * @private
   */
  getFormItems: function getFormItems() {
    // TODO replace with field manager version (see tasks)
    this.contactLinkPanel = new Tine.widgets.grid.LinkGridPanel({
      app: this.app,
      editDialog: this,
      searchRecordClass: Tine.Addressbook.Model.Contact,
      newRecordClass: Tine.Addressbook.Model.Contact,
      title: this.app.i18n._('Attendee'),
      typeColumnHeader: this.app.i18n._('Role'),
      searchComboConfig: {
        relationDefaults: {
          type: this.app.getRegistry().get('config')['projectAttendeeRole'].definition['default'],
          own_model: 'Projects_Model_Project',
          related_model: 'Addressbook_Model_Contact',
          related_degree: 'sibling',
          related_backend: 'Sql'
        }
      },
      relationTypesKeyfieldName: 'projectAttendeeRole'
    });
    const tasksApp = Tine.Tinebase.appMgr.get('Tasks');
    this.tasksLinkPanel = Tine.widgets.form.FieldManager.get(this.appName, this.modelName, 'tasks', Tine.widgets.form.FieldManager.CATEGORY_EDITDIALOG, {
      allowCreateNew: true,
      // TODO allow to auto-create this (but we need to switch Tasks frontend to MC / appstarter first)
      // columns: [
      //     'summary',
      //     'due',
      //     'priority',
      //     'percent',
      //     'status',
      // ]
      columns: [{
        id: 'summary',
        header: tasksApp.i18n._("Summary"),
        width: 130,
        dataIndex: 'summary',
        quickaddField: new Ext.form.TextField({
          emptyText: tasksApp.i18n._('Add a task...')
        })
      }, {
        id: 'due',
        header: tasksApp.i18n._("Due Date"),
        width: 100,
        dataIndex: 'due',
        renderer: Tine.Tinebase.common.dateRenderer,
        editor: new Ext.ux.form.ClearableDateField({//format : 'd.m.Y'
        }),
        quickaddField: new Ext.ux.form.ClearableDateField({//value: new Date(),
          //format : "d.m.Y"
        })
      }, {
        id: 'priority',
        header: tasksApp.i18n._("Priority"),
        width: 70,
        dataIndex: 'priority',
        renderer: Tine.Tinebase.widgets.keyfield.Renderer.get('Tasks', 'taskPriority'),
        editor: {
          xtype: 'widget-keyfieldcombo',
          app: 'Tasks',
          keyFieldName: 'taskPriority'
        },
        quickaddField: new Tine.Tinebase.widgets.keyfield.ComboBox({
          app: 'Tasks',
          keyFieldName: 'taskPriority'
        })
      }, {
        id: 'percent',
        header: tasksApp.i18n._("Percent"),
        width: 70,
        dataIndex: 'percent',
        renderer: Ext.ux.PercentRenderer,
        editor: new Ext.ux.PercentCombo({
          autoExpand: true,
          blurOnSelect: true
        }),
        quickaddField: new Ext.ux.PercentCombo({
          autoExpand: true
        })
      }, {
        id: 'status',
        header: tasksApp.i18n._("Status"),
        width: 100,
        dataIndex: 'status',
        renderer: Tine.Tinebase.widgets.keyfield.Renderer.get('Tasks', 'taskStatus'),
        editor: {
          xtype: 'widget-keyfieldcombo',
          app: 'Tasks',
          keyFieldName: 'taskStatus'
        },
        quickaddField: new Tine.Tinebase.widgets.keyfield.ComboBox({
          app: 'Tasks',
          keyFieldName: 'taskStatus',
          value: 'NEEDS-ACTION'
        })
      }]
    });
    return {
      xtype: 'tabpanel',
      plain: true,
      plugins: [{
        ptype: 'ux.tabpanelkeyplugin'
      }],
      defaults: {
        hideMode: 'offsets'
      },
      activeTab: 0,
      border: false,
      items: [{
        title: this.app.i18n._('Project'),
        autoScroll: true,
        border: false,
        frame: true,
        layout: 'border',
        items: [{
          region: 'center',
          layout: 'hfit',
          border: false,
          items: [{
            xtype: 'fieldset',
            layout: 'hfit',
            autoHeight: true,
            title: this.app.i18n._('Project'),
            items: [{
              xtype: 'columnform',
              labelAlign: 'top',
              formDefaults: {
                xtype: 'textfield',
                anchor: '100%',
                labelSeparator: '',
                columnWidth: .333
              },
              items: [[{
                columnWidth: 1,
                fieldLabel: this.app.i18n._('Title'),
                name: 'title',
                allowBlank: false
              }], [{
                columnWidth: .5,
                fieldLabel: this.app.i18n._('Number'),
                name: 'number'
              }, new Tine.Tinebase.widgets.keyfield.ComboBox({
                columnWidth: .5,
                app: 'Projects',
                keyFieldName: 'projectStatus',
                fieldLabel: this.app.i18n._('Status'),
                name: 'status'
              })], [{
                columnWidth: .5,
                fieldLabel: this.app.i18n._('Start'),
                xtype: 'extuxclearabledatefield',
                name: 'start'
              }, {
                columnWidth: .5,
                fieldLabel: this.app.i18n._('End'),
                xtype: 'extuxclearabledatefield',
                name: 'end'
              }], [new Tine.Tinebase.widgets.keyfield.ComboBox({
                columnWidth: .5,
                fieldLabel: this.app.i18n._('Scope'),
                app: 'Projects',
                keyFieldName: 'projectScope',
                name: 'scope'
              }), new Tine.Tinebase.widgets.keyfield.ComboBox({
                columnWidth: .5,
                fieldLabel: this.app.i18n._('Type'),
                app: 'Projects',
                keyFieldName: 'projectType',
                name: 'type'
              })]]
            }]
          }, {
            xtype: 'tabpanel',
            deferredRender: false,
            activeTab: 0,
            border: false,
            height: 250,
            form: true,
            items: [this.contactLinkPanel]
          }, {
            xtype: 'tabpanel',
            deferredRender: false,
            activeTab: 0,
            border: false,
            height: 200,
            form: true,
            items: [this.tasksLinkPanel]
          }]
        }, {
          // activities and tags
          layout: 'ux.multiaccordion',
          animate: true,
          region: 'east',
          width: 210,
          split: true,
          collapsible: true,
          collapseMode: 'mini',
          header: false,
          margins: '0 5 0 5',
          border: true,
          items: [new Tine.widgets.tags.TagPanel({
            app: 'Projects',
            border: false,
            bodyStyle: 'border:1px solid #B5B8C8;'
          }), new Ext.Panel({
            title: this.app.i18n._('Description'),
            iconCls: 'descriptionIcon',
            layout: 'form',
            labelAlign: 'top',
            border: false,
            items: [{
              style: 'margin-top: -4px; border 0px;',
              labelSeparator: '',
              xtype: 'textarea',
              name: 'description',
              hideLabel: true,
              grow: false,
              preventScrollbars: false,
              anchor: '100% 100%',
              emptyText: this.app.i18n._('Enter description'),
              requiredGrant: 'editGrant'
            }]
          })]
        }]
      }, new Tine.widgets.activities.ActivitiesTabPanel({
        app: this.appName,
        record_id: this.record.id,
        record_model: this.appName + '_Model_' + this.recordClass.getMeta('modelName')
      })]
    };
  }
});
/**
 * Projects Edit Popup
 * 
 * @param   {Object} config
 * @return  {Ext.ux.Window}
 */

Tine.Projects.ProjectEditDialog.openWindow = function (config) {
  var id = config.record && config.record.id ? config.record.id : 0;
  var window = Tine.WindowFactory.getWindow({
    width: 800,
    height: 800,
    name: Tine.Projects.ProjectEditDialog.prototype.windowNamePrefix + id,
    contentPanelConstructor: 'Tine.Projects.ProjectEditDialog',
    contentPanelConstructorConfig: config
  });
  return window;
};

/***/ }),

/***/ 2014:
/***/ (function(module, exports) {

/*
 * Tine 2.0
 * Projects combo box and store
 * 
 * @package     Projects
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Philipp Schüle <p.schuele@metaways.de>
 * @copyright   Copyright (c) 2007-2011 Metaways Infosystems GmbH (http://www.metaways.de)
 *
 */
Ext.ns('Tine.Projects');
/**
 * Project selection combo box
 * 
 * @namespace   Tine.Projects
 * @class       Tine.Projects.SearchCombo
 * @extends     Ext.form.ComboBox
 * 
 * <p>Project Search Combobox</p>
 * <p><pre>
 * TODO         make this a twin trigger field with 'clear' button?
 * TODO         add switch to filter for expired/enabled/disabled user accounts
 * </pre></p>
 * 
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Philipp Schuele <p.schuele@metaways.de>
 * @copyright   Copyright (c) 2007-2011 Metaways Infosystems GmbH (http://www.metaways.de)
 * 
 * @param       {Object} config
 * @constructor
 * Create a new Tine.Projects.SearchCombo
 * 
 * TODO         add     forceSelection: true ?
 */

Tine.Projects.SearchCombo = Ext.extend(Tine.Tinebase.widgets.form.RecordPickerComboBox, {
  allowBlank: false,
  itemSelector: 'div.search-item',
  minListWidth: 200,
  //private
  initComponent: function initComponent() {
    this.recordClass = Tine.Projects.Model.Project;
    this.recordProxy = Tine.Projects.recordBackend;
    this.initTemplate();
    Tine.Projects.SearchCombo.superclass.initComponent.call(this);
  },

  /**
   * use beforequery to set query filter
   * 
   * @param {Event} qevent
   */
  onBeforeQuery: function onBeforeQuery(qevent) {
    Tine.Projects.SearchCombo.superclass.onBeforeQuery.apply(this, arguments);
  },

  /**
   * init template
   * @private
   */
  initTemplate: function initTemplate() {
    // Custom rendering Template
    // TODO move style def to css ?
    if (!this.tpl) {
      this.tpl = new Ext.XTemplate('<tpl for="."><div class="search-item">', '<table cellspacing="0" cellpadding="2" border="0" style="font-size: 11px;" width="100%">', '<tr>', '<td style="height:16px">{[this.encode(values)]}</td>', '</tr>', '</table>', '</div></tpl>', {
        encode: function encode(values) {
          var ret = '<b>' + Ext.util.Format.htmlEncode(values.title) + '</b>';
          if (values.number) ret += ' (' + values.number + ')';
          return ret;
        }
      });
    }
  },
  getValue: function getValue() {
    return Tine.Projects.SearchCombo.superclass.getValue.call(this);
  },
  setValue: function setValue(value) {
    return Tine.Projects.SearchCombo.superclass.setValue.call(this, value);
  }
});
Tine.widgets.form.RecordPickerManager.register('Projects', 'Project', Tine.Projects.SearchCombo);

/***/ }),

/***/ 2015:
/***/ (function(module, exports) {

/*
 * Tine 2.0
 * 
 * @package     Projects
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Alexander Stintzing <alex@stintzing.net>
 * @copyright   Copyright (c) 2009-2012 Metaways Infosystems GmbH (http://www.metaways.de)
 *
 */
Ext.ns('Tine.Projects');
/**
 * @namespace   Tine.Projects
 * @class       Tine.Projects.AddToProjectPanel
 * @extends     Tine.widgets.dialog.AddToRecordPanel
 * @author      Alexander Stintzing <alex@stintzing.net>
 */

Tine.Projects.AddToProjectPanel = Ext.extend(Tine.widgets.dialog.AddToRecordPanel, {
  // private
  appName: 'Projects',
  callingApp: 'Addressbook',
  callingModel: 'Contact',

  /**
   * initializes the component
   */
  initComponent: function initComponent() {
    this.recordClass = Tine.Projects.Model.Project;
    Tine.Projects.AddToProjectPanel.superclass.initComponent.call(this);
  },

  /**
   * @see Tine.widgets.dialog.AddToRecordPanel::isValid()
   */
  isValid: function isValid() {
    var valid = true;

    if (this.searchBox.getValue() == '') {
      this.searchBox.markInvalid(this.app.i18n._('Please choose the Project to add the contacts to'));
      valid = false;
    }

    if (this.chooseRoleBox.getValue() == '') {
      this.chooseRoleBox.markInvalid(this.app.i18n._('Please select the attenders\' role'));
      valid = false;
    }

    return valid;
  },

  /**
   * @see Tine.widgets.dialog.AddToRecordPanel::getRelationConfig()
   */
  getRelationConfig: function getRelationConfig() {
    var config = {
      type: this.chooseRoleBox.getValue() ? this.chooseRoleBox.getValue() : 'COWORKER'
    };
    return config;
  },

  /**
   * @see Tine.widgets.dialog.AddToRecordPanel::getFormItems()
   */
  getFormItems: function getFormItems() {
    return {
      border: false,
      frame: false,
      layout: 'border',
      items: [{
        region: 'center',
        border: false,
        frame: false,
        layout: {
          align: 'stretch',
          type: 'vbox'
        },
        items: [{
          layout: 'form',
          margins: '10px 10px',
          border: false,
          frame: false,
          items: [Tine.widgets.form.RecordPickerManager.get('Projects', 'Project', {
            fieldLabel: this.app.i18n._('Select Project'),
            anchor: '100% 100%',
            ref: '../../../searchBox'
          }), {
            fieldLabel: this.app.i18n._('Role'),
            emptyText: this.app.i18n._('Select Role'),
            anchor: '100% 100%',
            xtype: 'widget-keyfieldcombo',
            app: 'Projects',
            value: 'COWORKER',
            keyFieldName: 'projectAttendeeRole',
            ref: '../../../chooseRoleBox'
          }]
        }]
      }]
    };
  }
});

Tine.Projects.AddToProjectPanel.openWindow = function (config) {
  var window = Tine.WindowFactory.getWindow({
    modal: true,
    title: String.format(Tine.Tinebase.appMgr.get('Projects').i18n._('Adding {0} Participants to project'), config.count),
    width: 250,
    height: 150,
    contentPanelConstructor: 'Tine.Projects.AddToProjectPanel',
    contentPanelConstructorConfig: config
  });
  return window;
};

/***/ }),

/***/ 2016:
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(2017);
if(typeof content === 'string') content = [[module.i, content, '']];
// Prepare cssTransformation
var transform;

var options = {"hmr":true}
options.transform = transform
// add the styles to the DOM
var update = __webpack_require__(17)(content, options);
if(content.locals) module.exports = content.locals;
// Hot Module Replacement
if(false) {}

/***/ }),

/***/ 2017:
/***/ (function(module, exports, __webpack_require__) {

var escape = __webpack_require__(100);
exports = module.exports = __webpack_require__(16)(false);
// imports


// module
exports.push([module.i, "/**\n * Tine 2.0\n * \n * @package     Projects\n * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3\n * @author      Philipp Schüle <p.schuele@metaways.de>\n * @copyright   Copyright (c) 2011 Metaways Infosystems GmbH (http://www.metaways.de)\n *\n */\n \n.ProjectsIconCls, .ProjectsProject {\n    background-image:url(" + escape(__webpack_require__(2018)) + ") !important;\n}", ""]);

// exports


/***/ }),

/***/ 2018:
/***/ (function(module, exports) {

module.exports = "\"data:image/svg+xml,%3C?xml version='1.0' encoding='utf-8'?%3E %3C!-- Generator: Adobe Illustrator 21.1.0, SVG Export Plug-In . SVG Version: 6.00 Build 0) --%3E %3Csvg version='1.1' id='Ebene_1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' x='0px' y='0px' viewBox='0 0 42.5 42.5' style='enable-background:new 0 0 42.5 42.5;' xml:space='preserve' width='42.5' height='42.5'%3E %3Cpath d='M34.9,11.2c0.4,0.4,0.7,0.8,0.9,1.4c0.3,0.6,0.4,1.2,0.4,1.7v21.9c0,0.5-0.2,0.9-0.5,1.3S34.8,38,34.3,38H8.8 c-0.5,0-0.9-0.2-1.3-0.5C7.2,37.1,7,36.7,7,36.2V5.8c0-0.5,0.2-0.9,0.5-1.3C7.9,4.2,8.3,4,8.8,4h17c0.5,0,1.1,0.1,1.7,0.4 c0.6,0.3,1.1,0.6,1.4,0.9L34.9,11.2z M26.4,6.6v7.1h7.1c-0.1-0.4-0.3-0.6-0.4-0.8L27.2,7C27.1,6.8,26.8,6.7,26.4,6.6z M33.7,35.6 V16.2h-7.9c-0.5,0-0.9-0.2-1.3-0.5c-0.4-0.4-0.5-0.8-0.5-1.3V6.4H9.4v29.2H33.7z M14.3,19.2c0-0.2,0.1-0.3,0.2-0.4 c0.1-0.1,0.3-0.2,0.4-0.2h13.4c0.2,0,0.3,0.1,0.4,0.2c0.1,0.1,0.2,0.3,0.2,0.4v1.2c0,0.2-0.1,0.3-0.2,0.4C28.6,21,28.4,21,28.3,21 H14.9c-0.2,0-0.3-0.1-0.4-0.2c-0.1-0.1-0.2-0.3-0.2-0.4V19.2z M28.3,23.4c0.2,0,0.3,0.1,0.4,0.2c0.1,0.1,0.2,0.3,0.2,0.4v1.2 c0,0.2-0.1,0.3-0.2,0.4c-0.1,0.1-0.3,0.2-0.4,0.2H14.9c-0.2,0-0.3-0.1-0.4-0.2c-0.1-0.1-0.2-0.3-0.2-0.4V24c0-0.2,0.1-0.3,0.2-0.4 c0.1-0.1,0.3-0.2,0.4-0.2H28.3z M28.3,28.3c0.2,0,0.3,0.1,0.4,0.2c0.1,0.1,0.2,0.3,0.2,0.4v1.2c0,0.2-0.1,0.3-0.2,0.4 c-0.1,0.1-0.3,0.2-0.4,0.2H14.9c-0.2,0-0.3-0.1-0.4-0.2c-0.1-0.1-0.2-0.3-0.2-0.4v-1.2c0-0.2,0.1-0.3,0.2-0.4 c0.1-0.1,0.3-0.2,0.4-0.2H28.3z'/%3E %3C/svg%3E\""

/***/ }),

/***/ 39:
/***/ (function(module, exports) {


/**
 * When source maps are enabled, `style-loader` uses a link element with a data-uri to
 * embed the css on the page. This breaks all relative urls because now they are relative to a
 * bundle instead of the current page.
 *
 * One solution is to only use full urls, but that may be impossible.
 *
 * Instead, this function "fixes" the relative urls to be absolute according to the current page location.
 *
 * A rudimentary test suite is located at `test/fixUrls.js` and can be run via the `npm test` command.
 *
 */

module.exports = function (css) {
  // get current location
  var location = typeof window !== "undefined" && window.location;

  if (!location) {
    throw new Error("fixUrls requires window.location");
  }

	// blank or null?
	if (!css || typeof css !== "string") {
	  return css;
  }

  var baseUrl = location.protocol + "//" + location.host;
  var currentDir = baseUrl + location.pathname.replace(/\/[^\/]*$/, "/");

	// convert each url(...)
	/*
	This regular expression is just a way to recursively match brackets within
	a string.

	 /url\s*\(  = Match on the word "url" with any whitespace after it and then a parens
	   (  = Start a capturing group
	     (?:  = Start a non-capturing group
	         [^)(]  = Match anything that isn't a parentheses
	         |  = OR
	         \(  = Match a start parentheses
	             (?:  = Start another non-capturing groups
	                 [^)(]+  = Match anything that isn't a parentheses
	                 |  = OR
	                 \(  = Match a start parentheses
	                     [^)(]*  = Match anything that isn't a parentheses
	                 \)  = Match a end parentheses
	             )  = End Group
              *\) = Match anything and then a close parens
          )  = Close non-capturing group
          *  = Match anything
       )  = Close capturing group
	 \)  = Match a close parens

	 /gi  = Get all matches, not the first.  Be case insensitive.
	 */
	var fixedCss = css.replace(/url\s*\(((?:[^)(]|\((?:[^)(]+|\([^)(]*\))*\))*)\)/gi, function(fullMatch, origUrl) {
		// strip quotes (if they exist)
		var unquotedOrigUrl = origUrl
			.trim()
			.replace(/^"(.*)"$/, function(o, $1){ return $1; })
			.replace(/^'(.*)'$/, function(o, $1){ return $1; });

		// already a full url? no change
		if (/^(#|data:|http:\/\/|https:\/\/|file:\/\/\/)/i.test(unquotedOrigUrl)) {
		  return fullMatch;
		}

		// convert the url to a full url
		var newUrl;

		if (unquotedOrigUrl.indexOf("//") === 0) {
		  	//TODO: should we add protocol?
			newUrl = unquotedOrigUrl;
		} else if (unquotedOrigUrl.indexOf("/") === 0) {
			// path should be relative to the base url
			newUrl = baseUrl + unquotedOrigUrl; // already starts with '/'
		} else {
			// path should be relative to current directory
			newUrl = currentDir + unquotedOrigUrl.replace(/^\.\//, ""); // Strip leading './'
		}

		// send back the fixed url(...)
		return "url(" + JSON.stringify(newUrl) + ")";
	});

	// send back the fixed css
	return fixedCss;
};


/***/ }),

/***/ 60:
/***/ (function(module, exports, __webpack_require__) {

/* pkg: Projects FAT Client (js/Projects-FAT.js)*/
__webpack_require__(2011);
__webpack_require__(2012);
__webpack_require__(2013);
__webpack_require__(2014);
__webpack_require__(2015);
/* pkg: Projects FAT Client (css/Projects-FAT.css)*/
__webpack_require__(2016);


/***/ })

}]);